/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Peque�a y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.gvsig.mini.common.j2se.impl;

import java.awt.Color;
import java.awt.Image;

import es.prodevelop.gvsig.mini.common.IBitmap;

/**
 * A fake implementation of Bitmap that contains a File. If the library is going
 * to be used to implement a map viewer a good implementation of IBitmap should
 * be provided
 * 
 * @author aromeu
 * 
 */
public class BitmapJ2SE implements IBitmap {

	Image img;
	static byte[] back = new byte[256 * 256];
	static {
		for (int i = 0; i < 256 * 256; i++) {
			back[i] = 0x000000;
		}
	}

	/**
	 * Fake constructor that takes a file
	 * 
	 * @param f
	 */
	public BitmapJ2SE(byte[] data, int offset, int length) {
		img = java.awt.Toolkit.getDefaultToolkit().createImage(data, offset,
				length);
	}

	/**
	 * Fake constructor that takes a file
	 * 
	 * @param f
	 */
	public BitmapJ2SE() {

		img = null;
	}

	public BitmapJ2SE(Image image) {

		img = image;
	}

	public Object getBitmap() {
		return img;
	}

	public void recycle() {
		img = null;
	}

}
