/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Peque�a y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.gvsig.mini.common.j2se.impl;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import es.prodevelop.gvsig.mini.common.IBitmap;
import es.prodevelop.gvsig.mini.common.IContext;
import es.prodevelop.gvsig.mini.common.IEvent;
import es.prodevelop.gvsig.mini.common.IHandler;
import es.prodevelop.gvsig.mini.common.IRect;
import es.prodevelop.tilecache.IDownloadCallbackHandler;

/**
 * Implementation of IContext that compiles for J2SE
 * @author aromeu
 *
 */
public class J2SEContext implements IContext {
	
	private String externalStoragePath = "./tilerastercache";

	public InputStream openAssetFile(String fileName) throws IOException {
		FileInputStream f = new FileInputStream("./assets/" + fileName);
		return f;
	}	

	public IBitmap decodeByteArray(byte[] data, int offset, int length) {
		return new BitmapJ2SE(data, offset, length);
	}

	public IBitmap getBitmapFromResource(int ID) {	
		return new BitmapJ2SE();
	}

	public String getExternalStorageDirectoryPath() {
		return this.externalStoragePath;
	}

	public boolean isSDMounted() {
		// TODO Auto-generated method stub
		return true;
	}

	public void sendMessage(IHandler handler, IEvent event, int ID) {
		((IDownloadCallbackHandler)handler.getHandler()).onNewMessage(ID, event);		
	}

	public void sendMessage(IHandler handler, int ID) {
		((IDownloadCallbackHandler)handler.getHandler()).onNewMessage(ID, null);		
	}

	public String getBaseLayerFilePath() {
		return "./assets/layers.txt";
	}

	public String getBaseLayerPersistFilePath() {
		return "./gvSIG/layers/";
	}

	public IRect getRectangle() {
		return new Rectangle();
	}


	public void setExternalStorageDirectoryPath(String path) {
		this.externalStoragePath = path;
	}

	public IBitmap decodeByteArray(InputStream in) throws IOException {
		// TODO Auto-generated method stub
		return null;
	}

	public IBitmap decodeByteArray(String filePath) throws IOException {
		// TODO Auto-generated method stub
		return null;
	}

	public int getDefaultLoadingTileID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int getDefaultOfflineTileID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public IBitmap createBitmap(int width, int height) {
		return null;
	}		
}
