/* gvSIG Mini. A free mobile phone viewer of free maps.
 *
 * Copyright (C) 2010 Prodevelop.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Prodevelop, S.L.
 *   Pza. Don Juan de Villarrasa, 14 - 5
 *   46001 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   prode@prodevelop.es
 *   http://www.prodevelop.es
 *
 *   gvSIG Mini has been partially funded by IMPIVA (Instituto de la Pequea y
 *   Mediana Empresa de la Comunidad Valenciana) &
 *   European Union FEDER funds.
 *   
 *   2010.
 *   author Alberto Romeu aromeu@prodevelop.es
 */

package es.prodevelop.gvsig.mini.common.j2se.impl;

import es.prodevelop.gvsig.mini.common.IRect;

/**
 * Wrapper of java.awt.Rectangle
 * 
 * @author aromeu
 * 
 */
public class Rectangle implements IRect {

	private java.awt.Rectangle instance;

	/**
	 * Internally instantiates a new java.awt.Rectangle
	 */
	public Rectangle() {
		instance = new java.awt.Rectangle();
	}

	/**
	 * Sets the properties on a java.awt.Rectangle
	 * 
	 * @param left
	 * @param top
	 * @param right
	 * @param bottom
	 */
	public Rectangle(int left, int top, int right, int bottom) {
		this();
		this.set(left, top, right, bottom);
	}

	
	public boolean intersects(int left, int top, int right, int bottom) {
		boolean b1 = instance.intersects(left, top, Math.abs(right - left),
				Math.abs(bottom - top));
//		boolean b2 = instance.contains(left, top, Math.abs(right - left), Math
//				.abs(bottom - top));
//		boolean b3 = new java.awt.Rectangle(left, top, Math.abs(right - left),
//				Math.abs(bottom - top)).contains(instance);

		return b1;
	}

	
	public void set(int left, int top, int right, int bottom) {
		instance.x = left;
		instance.y = top;
		instance.width = Math.max(Math.abs(right - left), 1);
		instance.height = Math.max(Math.abs(bottom - top), 1);
	}

	
	public int getArea() {
		return instance.width * instance.height;
	}

}
